AMH 5.X下安装 Flarum

背景

最近无意间发现几个开源软件的Bug反馈系统使用的是Flarum,Flarum是一款优雅简洁论坛软件,看起来还是相当不错的,一时抑制不住想要尝试一下。

由于服务器使用的是AMH集成环境,它相对于通常的直接安装环境有很多的区别,这导致安装过程中产生里不少问题。这里做个总结。

Flarum

Flarum 是一款优雅简洁论坛软件,让在线交流变得更加轻松愉快。

AMH

AMH 是国内首个开源的主机面板,AMH 支持用户自由弹性组建运行环境与切换环境,您可以下载安装不同版本的WEB服务器、数据库、脚本软件自由组合创建您需要的运行环境。

我使用的是AMH5.X的付费版本,4.X的免费版本也可以参考本教程。

目前服务器环境是LNMP:

CentOS-6.6 64位

lnmp-2.5

mysql-generic-5.5.40

nginx-generic-1.6.0

php-7.0

Composer

Composer是 PHP 用来管理依赖(dependency)关系的工具。你可以在自己的项目中声明所依赖的外部工具库(libraries),Composer 会帮你安装这些依赖的库文件。

Composer是安装Flarum的必要工具。

安装PHP扩展

这里需要安装Flarum所需要的必要的PHP扩展,先看下系统需求:

Flarum 系统需求

服务器: Apache (需要支持 mod_rewrite)、Nginx、Lighttpd
PHP 5.5+,需要开启的扩展:mbstring, pdo_mysql, openssl, json, gd, dom, fileinfo
MySQL 5.5+

特别注意:PHP是5.5+、MySQL 5.5+,如果版本过低可以使用AMH安装更高版本,AMH支持多版本PHP和MySQL。

流程:

  1. 登录到AMH的管理面板
  2. 软件下载 > fileinfo-1.0 > 下载并安装到对应的环境
  3. 软件下载 > mcrypt-1.0 > 下载并安装到对应的环境
  4. 软件下载 > pdo_mysql-1.0 > 下载并安装到对应的环境

安装Composer

Flarum官网的文档要求使用Composer命令行的方式进行安装,所以需要先安装Composer:

使用SSH方式登录服务器之后:执行

curl -sS https://getcomposer.org/installer | php

注意: 如果上述方法由于某些原因失败了,你还可以通过 php >下载安装器:

php -r "readfile('https://getcomposer.org/installer');" | php

这里你可能会遇到 -bash php command not found的错误提示,请参考下文的问题集锦

PS:安装Composer文档

安装Flarum

环境搭建好了,这里讲解安装Flarum的过程

官方安装文档

  1. 在AMH控制面板下创建好一个站点(这里指定为A站点),并做好域名解析,确认可以正常访问
  2. 删除A站点下的所有文件
  3. 创建好一个Flarum使用的MySQL数据库和对应的用户
  4. SSH下进入A站点根目录(cd /home/wwwroot/环境/domain/主域名/web/
  5. 执行安装命令:composer create-project flarum/flarum . --stability=beta
  6. 配置A站点的Nginx配置文件(/home/wwwroot/环境/vhost/主域名.conf):参见官方安装文档。特别注意:location ~* \.php$下的参数以自动生成的为准,还需要删除自动生成的ErrorPage的配置信息。
  7. 重载Nginx并访问A站点,填写相关安装信息。(遇到文件读写权限问题,查看下文问题集锦)

安装Flarum中文语言包

为了便于操作,我们安装中文语言包来进行默认语言的切换。

尝试了几种安装方式,这里推荐使用命令行安装:

  1. SSH下进入A站点根目录
  2. 执行composer require jsthon/flarum-ext-simplified-chinese即可
  3. 访问A站点,进入后台修改勾选中文扩展,并修改默认语言。

其他语言和扩展:https://discuss.flarum.org/d/1534-extension-list

问题集锦

可能遇到的问题:

-bash php command not found

Composer的安装和使用是使用的php-cli的方式,AMH支持多版本的PHP,环境变量里并未指定php-cli的版本,这里需要我们把指定版本的PHP加入到环境变量里。

~/.bash_profile里加入:

1
2
PATH=$PATH:/usr/local/php-版本/bin
export PATH

保存修改后执行source ~/.bash_profile使得修改生效。

PS:如果你使用的是其他发行版的Linux,请自行搜索如何设置PHP加入到环境变量

requires ext-fileinfo * 或者 request for intervention/image

参见:

简单来说,就是咱们在AMH里安装的PHP扩展并没有影响到php-cli方式运行PHP的配置,需要我们手动同步一下配置:

cp /home/wwwroot/环境/etc/amh-php.ini /usr/local/php-版本/etc/php.ini

重载Nginx即可生效。

Please chmod this directory to 0775

当你访问通过composer安装好的A站点时,遇到里类似的权限读写问题,对于AMH环境,我们需要执行:

sudo chown www:www -R /home/wwwroot/环境/domain/主域名/web

这里有一些讨论:

上面的讨论使用的用户组和AMH的不一样,AMH网站的用户组是www,结合实际情况才能真正解决问题。

其他

查看我们的成果:Cafeting的论坛

官方文档 适应最新版的Flarum,推荐
中文文档 较旧,有一定参考意义

AMH集成环境相对于通常的直接安装环境有很多的区别,使用的时候务必要考虑到。

PS:你可以通过下面的方式和我联系